Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class DayTimeDurationValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.DurationValue
                  net.sf.saxon.value.DayTimeDurationValue

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, Item, ValueRepresentation

    public final class DayTimeDurationValue

extends DurationValue
implements Comparable

A value of type xs:dayTimeDuration

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`DayTimeDurationValue(CharSequence s)` Constructor: create a duration value from a supplied string, in ISO 8601 format [-]PnDTnHnMnS
`DayTimeDurationValue(int sign, int days, int hours, int minutes, int seconds, int microseconds)` Create a dayTimeDuration given the number of days, hours, minutes, and seconds.

Method Summary
`DurationValue` | `add(DurationValue other)` Add two dayTimeDurations
`int` | `compareTo(Object other)` Compare the value to another duration value
`Object` | `convertToJava(Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`AtomicValue` | `copy(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`DecimalValue` | `divide(DurationValue other)` Find the ratio between two durations
`static DayTimeDurationValue` | `fromMicroseconds(long microseconds)` Construct a duration value as a number of microseconds.
`static DayTimeDurationValue` | `fromMilliseconds(long milliseconds)` Construct a duration value as a number of milliseconds.
`static DayTimeDurationValue` | `fromSeconds(BigDecimal seconds)` Construct a duration value as a number of seconds.
`long` | `getLengthInMicroseconds()` Get length of duration in microseconds, as a long
`long` | `getLengthInMilliseconds()` Get length of duration in milliseconds, as a long
`double` | `getLengthInSeconds()` Get length of duration in seconds
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`Comparable` | `getSchemaComparable()` Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.
`CharSequence` | `getStringValueCS()` Convert to string
`Comparable` | `getXPathComparable()` Get a Comparable value that implements the XPath ordering comparison semantics for this value.
`DurationValue` | `multiply(double n)` Multiply duration by a number.
`DurationValue` | `negate()` Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
`void` | `normalize()` Normalize the value, for example 90M becomes 1H30M
`DurationValue` | `subtract(DurationValue other)` Subtract two dayTime-durations

Methods inherited from class net.sf.saxon.value.DurationValue
`convertPrimitive, equals, getComponent, getDays, getHours, getMicroseconds, getMinutes, getMonths, getSchemaComparable, getSeconds, getStringValue, getYears, hashCode, normalizeDuration, signum`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, effectiveBooleanValue, getCardinality, getItemType, getLength, getTypedValue, getTypeLabel, hasBuiltInType, isMultiValued, itemAt, iterate, process, setTypeLabel, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convert, convertJavaObjectToXPath, fromItem, getCanonicalLexicalRepresentation, getIterator, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DayTimeDurationValue

    public DayTimeDurationValue(CharSequence s)
                         throws XPathException

  Constructor: create a duration value from a supplied string, in ISO 8601 format [-]PnDTnHnMnS

  Throws:
    `XPathException`

### DayTimeDurationValue

    public DayTimeDurationValue(int sign,
                                int days,
                                int hours,
                                int minutes,
                                int seconds,
                                int microseconds)
                         throws ValidationException

  Create a dayTimeDuration given the number of days, hours, minutes, and seconds. This constructor performs no validation

  Throws:
    `ValidationException`

Method Detail

### copy

    public AtomicValue copy(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Overrides:
    `copy` in class `DurationValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Overrides:
    `getPrimitiveType` in class `DurationValue`

### getStringValueCS

    public CharSequence getStringValueCS()

  Convert to string

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `DurationValue`
  Returns:
    ISO 8601 representation.
  See Also:
    `Item.getStringValue()`

### normalize

    public void normalize()
                   throws ValidationException

  Normalize the value, for example 90M becomes 1H30M

  Throws:
    `ValidationException`

### getLengthInSeconds

    public double getLengthInSeconds()

  Get length of duration in seconds

  Overrides:
    `getLengthInSeconds` in class `DurationValue`

### getLengthInMilliseconds

    public long getLengthInMilliseconds()

  Get length of duration in milliseconds, as a long

### getLengthInMicroseconds

    public long getLengthInMicroseconds()

  Get length of duration in microseconds, as a long

### fromSeconds

    public static DayTimeDurationValue fromSeconds(BigDecimal seconds)
                                            throws XPathException

  Construct a duration value as a number of seconds.

  Throws:
    `XPathException`

### fromMilliseconds

    public static DayTimeDurationValue fromMilliseconds(long milliseconds)
                                                 throws XPathException

  Construct a duration value as a number of milliseconds.

  Throws:
    `XPathException`

### fromMicroseconds

    public static DayTimeDurationValue fromMicroseconds(long microseconds)
                                                 throws IllegalArgumentException

  Construct a duration value as a number of microseconds.

  Parameters:
    `microseconds` - the number of microseconds in the duration. The maximum and minimum limits are such that the number of days in the duration must fit in a 32-bit signed integer.
  Throws:
    `IllegalArgumentException` - if the value is out of range.

### multiply

    public DurationValue multiply(double n)
                           throws XPathException

  Multiply duration by a number. This is also used when dividing a duration by a number.

  Overrides:
    `multiply` in class `DurationValue`
  Throws:
    `XPathException`

### divide

    public DecimalValue divide(DurationValue other)
                        throws XPathException

  Find the ratio between two durations

  Overrides:
    `divide` in class `DurationValue`
  Parameters:
    `other` - the dividend
  Returns:
    the ratio, as a decimal
  Throws:
    `XPathException`

### add

    public DurationValue add(DurationValue other)
                      throws XPathException

  Add two dayTimeDurations

  Overrides:
    `add` in class `DurationValue`
  Throws:
    `XPathException`

### subtract

    public DurationValue subtract(DurationValue other)
                           throws XPathException

  Subtract two dayTime-durations

  Overrides:
    `subtract` in class `DurationValue`
  Throws:
    `XPathException`

### negate

    public DurationValue negate()
                         throws IllegalArgumentException

  Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)

  Overrides:
    `negate` in class `DurationValue`
  Throws:
    `IllegalArgumentException` - in the extremely unlikely event that the duration is one that cannot be negated (because the limit for positive durations is one day off from the limit for negative durations)

### compareTo

    public int compareTo(Object other)

  Compare the value to another duration value

  Specified by:
    `compareTo` in interface `Comparable`
  Overrides:
    `compareTo` in class `Value`
  Parameters:
    `other` - The other dateTime value
  Returns:
    negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)

### getSchemaComparable

    public Comparable getSchemaComparable()

  Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. Returns null if the value is not comparable according to XML Schema rules. This implementation handles the ordering rules for durations in XML Schema, which for this subtype are identical to the XPath rules.

  Overrides:
    `getSchemaComparable` in class `DurationValue`

### getXPathComparable

    public Comparable getXPathComparable()

  Get a Comparable value that implements the XPath ordering comparison semantics for this value. Returns null if the value is not comparable according to XPath rules. The default implementation returns the value itself. This is modified for types such as xs:duration which allow ordering comparisons in XML Schema, but not in XPath.

  Overrides:
    `getXPathComparable` in class `DurationValue`

### convertToJava

    public Object convertToJava(Class target,
                                XPathContext context)
                         throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `DurationValue`
  Throws:
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.